/* plot_trk - plot position around a pseudo-oval track */
#include "local.h"
#include "screen.h"
#define LIN_ORIGIN 11
#define COL_ORIGIN 40
#define NPOINTS 26
#define IMAX (NPOINTS - 1)
#define POS(n, signlin, signcol) \
	scr_curs(LIN_ORIGIN + (signlin) * coords[n].lin, \
		COL_ORIGIN + (signcol) * coords[n].col)
static struct coords
	{
	short lin, col;
	} coords[NPOINTS] =
	{		/* points for one quadrant (quarter-screen) */
	{11,  0},  {11,  2},  {11,  4},  {11,  6},  {11,  8},
	{11, 10},  {11, 12},  {11, 14},  {11, 16},  {11, 18},
	{11, 20},  {11, 22},  {11, 24},  {11, 26},  {11, 28},
	{10, 29},  { 9, 30},  { 8, 31},  { 7, 32},  { 6, 33},
	{ 5, 34},  { 4, 35},  { 3, 36},  { 2, 36},  { 1, 36},
	{ 0, 36},
	};																			                                                            /*
.PE
.PS 26
/* plot_trk - plot a point */
void plot_trk(n, c)
	int n;
	char c;
	{
	asserts(n >= 0, "plot_trk: n is non-negative");
	n %= 4 * IMAX;
	if (n < IMAX)
		POS(n, 1, 1);				/* 1st quadrant - lower right */
	else if (n < 2 * IMAX)
		POS(2 * IMAX - n, -1, 1);	/* 2nd quadrant - upper right */
	else if (n < 3 * IMAX)
		POS(n - 2 * IMAX, -1, -1);	/* 3rd quadrant - upper left */
	else
		POS(4 * IMAX - n, 1, -1);	/* 4th quadrant - lower left */
	scr_putc(c);
	}
